From 9578cf114d71246970b198802083f42bf1472321 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 25 2020 22:36:59 +0000
Subject: [PATCH 1542/2232] Add static assertions on type equality of Vec iterators


---

diff --git a/src/cxx.cc b/src/cxx.cc
index 28506ef..cd72d82 100644
--- a/src/cxx.cc
+++ b/src/cxx.cc
@@ -191,6 +191,16 @@ static_assert(std::is_trivially_move_assignable<Slice<uint8_t>>::value,
 static_assert(std::is_trivially_destructible<Slice<uint8_t>>::value,
               "trivial ~Slice()");
 
+static_assert(std::is_same<Vec<uint8_t>::const_iterator,
+                           Vec<const uint8_t>::iterator>::value,
+              "Vec<T>::const_iterator == Vec<const T>::iterator");
+static_assert(std::is_same<Vec<const uint8_t>::const_iterator,
+                           Vec<const uint8_t>::iterator>::value,
+              "Vec<const T>::const_iterator == Vec<const T>::iterator");
+static_assert(
+    !std::is_same<Vec<uint8_t>::const_iterator, Vec<uint8_t>::iterator>::value,
+    "Vec<T>::const_iterator != Vec<T>::iterator");
+
 extern "C" {
 const char *cxxbridge1$error(const char *ptr, size_t len) {
   char *copy = new char[len];

